/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SourceColumnDTO type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SourceColumnDTO{}

// SourceColumnDTO struct for SourceColumnDTO
type SourceColumnDTO struct {
	ColumnId *string `json:"column_id,omitempty"`
	Label    *string `json:"label,omitempty"`
	Hash     *string `json:"hash,omitempty"`
	Size     *int32  `json:"size,omitempty"`
	Type     *string `json:"type,omitempty"`
}

// NewSourceColumnDTO instantiates a new SourceColumnDTO object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSourceColumnDTO() *SourceColumnDTO {
	this := SourceColumnDTO{}
	return &this
}

// NewSourceColumnDTOWithDefaults instantiates a new SourceColumnDTO object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSourceColumnDTOWithDefaults() *SourceColumnDTO {
	this := SourceColumnDTO{}
	return &this
}

// GetColumnId returns the ColumnId field value if set, zero value otherwise.
func (o *SourceColumnDTO) GetColumnId() string {
	if o == nil || IsNil(o.ColumnId) {
		var ret string
		return ret
	}
	return *o.ColumnId
}

// GetColumnIdOk returns a tuple with the ColumnId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceColumnDTO) GetColumnIdOk() (*string, bool) {
	if o == nil || IsNil(o.ColumnId) {
		return nil, false
	}
	return o.ColumnId, true
}

// HasColumnId returns a boolean if a field has been set.
func (o *SourceColumnDTO) HasColumnId() bool {
	if o != nil && !IsNil(o.ColumnId) {
		return true
	}

	return false
}

// SetColumnId gets a reference to the given string and assigns it to the ColumnId field.
func (o *SourceColumnDTO) SetColumnId(v string) {
	o.ColumnId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *SourceColumnDTO) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceColumnDTO) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *SourceColumnDTO) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *SourceColumnDTO) SetLabel(v string) {
	o.Label = &v
}

// GetHash returns the Hash field value if set, zero value otherwise.
func (o *SourceColumnDTO) GetHash() string {
	if o == nil || IsNil(o.Hash) {
		var ret string
		return ret
	}
	return *o.Hash
}

// GetHashOk returns a tuple with the Hash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceColumnDTO) GetHashOk() (*string, bool) {
	if o == nil || IsNil(o.Hash) {
		return nil, false
	}
	return o.Hash, true
}

// HasHash returns a boolean if a field has been set.
func (o *SourceColumnDTO) HasHash() bool {
	if o != nil && !IsNil(o.Hash) {
		return true
	}

	return false
}

// SetHash gets a reference to the given string and assigns it to the Hash field.
func (o *SourceColumnDTO) SetHash(v string) {
	o.Hash = &v
}

// GetSize returns the Size field value if set, zero value otherwise.
func (o *SourceColumnDTO) GetSize() int32 {
	if o == nil || IsNil(o.Size) {
		var ret int32
		return ret
	}
	return *o.Size
}

// GetSizeOk returns a tuple with the Size field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceColumnDTO) GetSizeOk() (*int32, bool) {
	if o == nil || IsNil(o.Size) {
		return nil, false
	}
	return o.Size, true
}

// HasSize returns a boolean if a field has been set.
func (o *SourceColumnDTO) HasSize() bool {
	if o != nil && !IsNil(o.Size) {
		return true
	}

	return false
}

// SetSize gets a reference to the given int32 and assigns it to the Size field.
func (o *SourceColumnDTO) SetSize(v int32) {
	o.Size = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *SourceColumnDTO) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceColumnDTO) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *SourceColumnDTO) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *SourceColumnDTO) SetType(v string) {
	o.Type = &v
}

func (o SourceColumnDTO) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SourceColumnDTO) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ColumnId) {
		toSerialize["column_id"] = o.ColumnId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Hash) {
		toSerialize["hash"] = o.Hash
	}
	if !IsNil(o.Size) {
		toSerialize["size"] = o.Size
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableSourceColumnDTO struct {
	value *SourceColumnDTO
	isSet bool
}

func (v NullableSourceColumnDTO) Get() *SourceColumnDTO {
	return v.value
}

func (v *NullableSourceColumnDTO) Set(val *SourceColumnDTO) {
	v.value = val
	v.isSet = true
}

func (v NullableSourceColumnDTO) IsSet() bool {
	return v.isSet
}

func (v *NullableSourceColumnDTO) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSourceColumnDTO(val *SourceColumnDTO) *NullableSourceColumnDTO {
	return &NullableSourceColumnDTO{value: val, isSet: true}
}

func (v NullableSourceColumnDTO) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSourceColumnDTO) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
